Package ec.gp.koza

# Class KozaNodeSelector

java.lang.Object
ec.gp.koza.KozaNodeSelector

All Implemented Interfaces:
  `GPNodeSelector`, `Prototype`, `Setup`, `Serializable`, `Cloneable`

public class KozaNodeSelector extends Object implements GPNodeSelector
KozaNodeSelector is a GPNodeSelector which picks nodes in trees a-la Koza I, with the addition of having a probability of always picking the root. The method divides the range 0.0...1.0 into four probability areas:

- One area specifies that the selector must pick a terminal.
- Another area specifies that the selector must pick a nonterminal (if there is one, else a terminal).
- The third area specifies that the selector pick the root node.
- The fourth area specifies that the selector pick any random node.

The KozaNodeSelector chooses by probability between these four situations. Then, based on the situation it has picked, it selects either a random terminal, nonterminal, root, or arbitrary node from the tree and returns it.

As the selector picks a node, it builds up some statistics information which makes it able to pick a little faster in subsequent passes. Thus if you want to reuse this selector on another tree, you need to call reset() first.

Parameters

base.`terminals` 0.0 <= double <= 1.0, nonterminals + terminals + root invalid input: '<'= 1.0 | (the probability we must pick a terminal)
base.`nonterminals` 0.0 <= double <= 1.0, nonterminals + terminals + root invalid input: '<'= 1.0 | (the probability we must pick a nonterminal if possible)
base.`root` 0.0 <= double <= 1.0, nonterminals + terminals + root invalid input: '<'= 1.0 | (the probability we must pick the root)

DefaultBase
gp.koza.ns

See Also:
  - Serialized Form

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `int`
  `nodes`
  The number of nodes in the tree, -1 if unknown.
  `double`
  `nonterminalProbability`
  The probability a nonterminal must be chosen.
  `int`
  `nonterminals`
  The number of nonterminals in the tree, -1 if unknown.
  `static final String`
  `P_NODESELECTOR`
  `static final String`
  `P_NONTERMINAL_PROBABILITY`
  `static final String`
  `P_ROOT_PROBABILITY`
  `static final String`
  `P_TERMINAL_PROBABILITY`
  `double`
  `rootProbability`
  The probability the root must be chosen
  `double`
  `terminalProbability`
  The probability a terminal must be chosen
  `int`
  `terminals`
  The number of terminals in the tree, -1 if unknown.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `KozaNodeSelector()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Object`
  `clone()`
  Creates a new individual cloned from a prototype, and suitable to begin use in its own evolutionary context.
  `Parameter`
  `defaultBase()`
  Returns the default base for this prototype.
  `GPNode`
  `pickNode(EvolutionState s, int subpopulation, int thread, GPIndividual ind, GPTree tree)`
  Picks a node at random from tree and returns it.
  `void`
  `reset()`
  Resets the Node Selector before a new series of pickNode() if need be.
  `void`
  `setup(EvolutionState state, Parameter base)`
  Sets up the object by reading it from the parameters stored in state, built off of the parameter base base.

  ### Methods inherited from class java.lang.Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### P_NODESELECTOR

    public static final String P_NODESELECTOR
    See Also:
      - Constant Field Values

  - ### P_TERMINAL_PROBABILITY

    public static final String P_TERMINAL_PROBABILITY
    See Also:
      - Constant Field Values

  - ### P_NONTERMINAL_PROBABILITY

    public static final String P_NONTERMINAL_PROBABILITY
    See Also:
      - Constant Field Values

  - ### P_ROOT_PROBABILITY

    public static final String P_ROOT_PROBABILITY
    See Also:
      - Constant Field Values

  - ### rootProbability

    public double rootProbability
    The probability the root must be chosen

  - ### terminalProbability

    public double terminalProbability
    The probability a terminal must be chosen

  - ### nonterminalProbability

    public double nonterminalProbability
    The probability a nonterminal must be chosen.

  - ### nonterminals

    public int nonterminals
    The number of nonterminals in the tree, -1 if unknown.

  - ### terminals

    public int terminals
    The number of terminals in the tree, -1 if unknown.

  - ### nodes

    public int nodes
    The number of nodes in the tree, -1 if unknown.

- ## Constructor Details

  - ### KozaNodeSelector

    public KozaNodeSelector()

- ## Method Details

  - ### defaultBase

    public Parameter defaultBase()
    Description copied from interface: `Prototype`
    Returns the default base for this prototype. This should generally be implemented by building off of the static base() method on the DefaultsForm object for the prototype's package. This should be callable during setup(...).
    Specified by:
      `defaultBase` in interface `Prototype`

  - ### clone

    public Object clone()
    Description copied from interface: `Prototype`
    Creates a new individual cloned from a prototype, and suitable to begin use in its own evolutionary context.

    Typically this should be a full "deep" clone. However, you may share certain elements with other objects rather than clone hem, depending on the situation:

    - If you hold objects which are shared with other instances, don't clone them.
    - If you hold objects which must be unique, clone them.
    - If you hold objects which were given to you as a gesture of kindness, and aren't owned by you, you probably shouldn't clone them.
    - DON'T attempt to clone: Singletons, Cliques, or Populations, or Subpopulation.
    - Arrays are not cloned automatically; you may need to clone an array if you're not sharing it with other instances. Arrays have the nice feature of being copyable by calling clone() on them.

    Implementations.

    - If no ancestor of yours implements clone(), and you have no need to do clone deeply, and you are abstract, then you should not declare clone().
    - If no ancestor of yours implements clone(), and you have no need to do clone deeply, and you are not abstract, then you should implement it as follows:

      ``

           public Object clone()
               {
               try
                   {
                   return super.clone();
                   }
               catch ((CloneNotSupportedException e)
                   { throw new InternalError(); } // never happens
               }

    - If no ancestor of yours implements clone(), but you need to deep-clone some things, then you should implement it as follows:

      ``

           public Object clone()
               {
               try
                   {
                   MyObject myobj = (MyObject) (super.clone());

                   // put your deep-cloning code here...
                   }
               catch ((CloneNotSupportedException e)
                   { throw new InternalError(); } // never happens
               return myobj;
               }

    - If an ancestor has implemented clone(), and you also need to deep clone some things, then you should implement it as follows:

      ``

           public Object clone()
               {
               MyObject myobj = (MyObject) (super.clone());

               // put your deep-cloning code here...

               return myobj;
               }

    Specified by:
      `clone` in interface `Prototype`
    Overrides:
      `clone` in class `Object`

  - ### setup

    public void setup(EvolutionState state, Parameter base)
    Description copied from interface: `Prototype`
    Sets up the object by reading it from the parameters stored in state, built off of the parameter base base. If an ancestor implements this method, be sure to call super.setup(state,base); before you do anything else.

    For prototypes, setup(...) is typically called once for the prototype instance; cloned instances do not receive the setup(...) call. setup(...) may be called more than once; the only guarantee is that it will get called at least once on an instance or some "parent" object from which it was ultimately cloned.

    Specified by:
      `setup` in interface `Prototype`
    Specified by:
      `setup` in interface `Setup`

  - ### reset

    public void reset()
    Description copied from interface: `GPNodeSelector`
    Resets the Node Selector before a new series of pickNode() if need be.
    Specified by:
      `reset` in interface `GPNodeSelector`

  - ### pickNode

    public GPNode pickNode(EvolutionState s, int subpopulation, int thread, GPIndividual ind, GPTree tree)
    Description copied from interface: `GPNodeSelector`
    Picks a node at random from tree and returns it. The tree is located in ind, which is located in s.population[subpopulation]. This method will be preceded with a call to reset(); afterwards, pickNode(...) may be called several times for the same tree.
    Specified by:
      `pickNode` in interface `GPNodeSelector`